# Usage existing model in PyTorch cpp API

Let's create a simple neural network for common classification problem.

Train it and then [use this trained model via cpp api](https://pytorch.org/tutorials/advanced/cpp_export.html).

[Here is](https://git.jinr.ru/bdrum/torch-cpp-api-test/-/blob/master/notebooks/nn.ipynb) the simple neural network which classifies vector size of 50 implemented and saved as model.

Just for information

~~~bash
du -h libtorch --max-depth=0
907M    libtorch
~~~

In order to run it via cpp see cmakelists and src/loadModel.cpp

~~~bash
[17:25:37][bdrum@RUMLAB .../spd/torch-cpp-api-test/build](master *)$ cmake ..
-- The CXX compiler identification is Clang 12.0.0
-- Detecting CXX compiler ABI info
-- Detecting CXX compiler ABI info - done
-- Check for working CXX compiler: /usr/bin/clang++ - skipped
-- Detecting CXX compile features
-- Detecting CXX compile features - done
-- Looking for C++ include pthread.h
-- Looking for C++ include pthread.h - found
-- Performing Test CMAKE_HAVE_LIBC_PTHREAD
-- Performing Test CMAKE_HAVE_LIBC_PTHREAD - Failed
-- Looking for pthread_create in pthreads
-- Looking for pthread_create in pthreads - not found
-- Looking for pthread_create in pthread
-- Looking for pthread_create in pthread - found
-- Found Threads: TRUE  
-- Found Torch: /home/bdrum/dev/libtorch/lib/libtorch.so  
-- Found benchmark: /home/bdrum/dev/google/benchmark/build/src/libbenchmark.a  
-- Configuring done
-- Generating done
-- Build files have been written to: /mnt/d/GoogleDrive/Job/spd/torch-cpp-api-test/build
[17:25:48][bdrum@RUMLAB .../spd/torch-cpp-api-test/build](master *)$ make
Scanning dependencies of target exec
[ 50%] Building CXX object src/CMakeFiles/exec.dir/loadModel.cpp.o
[100%] Linking CXX executable exec
[100%] Built target exec
~~~

## Benchmarks

Benchmarks for pretrained model for different input vector sizes:

- **1000**
- **5000**
- **10000**

are presented

~~~bash
[17:25:55][bdrum@RUMLAB .../spd/torch-cpp-api-test/build](master *)$ ./src/exec 
2021-10-05T17:25:58+03:00
Running ./src/exec
Run on (12 X 2208.01 MHz CPU s)
CPU Caches:
  L1 Data 32 KiB (x6)
  L1 Instruction 32 KiB (x6)
  L2 Unified 256 KiB (x6)
  L3 Unified 9216 KiB (x1)
Load Average: 0.49, 0.43, 0.57
-------------------------------------------------------------
Benchmark                   Time             CPU   Iterations
-------------------------------------------------------------
BM_RUN_MODEL/1000       0.03437 s      0.00954 s        69
BM_RUN_MODEL/5000       0.38984 s      0.05929 s        10
BM_RUN_MODEL/10000      1.41330 s      0.20476 s         3


ls -lah

4.3M nn_model_1000.pt
 98M nn_model_5000.pt
386M nn_model_10000.pt
~~~
