#include <benchmark/benchmark.h>
#include <torch/script.h>

#include <iostream>
#include <memory>

void RunModel(int num) {

  torch::jit::script::Module module;
  try {
    // Deserialize the ScriptModule from a file using torch::jit::load().
    module = torch::jit::load(
        "/mnt/d/GoogleDrive/Job/spd/torch-cpp-api-test/models/nn_model_" +
        std::to_string(num) + ".pt");
  } catch (const c10::Error &e) {
    std::cerr << "error loading the model\n";
  }

  // std::cout
  //     << "model loading "
  //     << "/mnt/d/GoogleDrive/Job/spd/torch-cpp-api-test/models/nn_model_" +
  //            std::to_string(num) + ".pt"
  //     << " is ok\n";

  auto tns = torch::rand({1, num});
  // Create a vector of inputs.
  std::vector<torch::jit::IValue> inputs;
  inputs.push_back(tns);

  // std::cout << tns << std::endl;
  // Execute the model and turn its output into a tensor.
  at::Tensor output = module.forward(inputs).toTensor();
  // std::cout << output << std::endl;
}

static void BM_RUN_MODEL(benchmark::State &state) {
  // Perform setup here
  for (auto _ : state) {
    // This code gets timed
    RunModel(state.range(0));
  }
}
// Register the function as a benchmark
BENCHMARK(BM_RUN_MODEL)->Arg(1000)->Arg(5000)->Arg(10000);
// Run the benchmark
BENCHMARK_MAIN();
